data example1;
  input C$ Y X1 X2 X8 @@;
  datalines;
  D  0  10.2  6  0.8     A  1  12.2  6  0.6     D  1   7.7  1  0.6     G  1  10.9  7  0.2 
  E  0  17.3  6  0.4     A  0  18.7  4    1     B  0   7.2  1  0.8     D  0   0.1  3  0.8 
  B  1   2.4  4    0     G  0  15.6  7    1     G  0  11.1  3  0.6     A  0     4  6  0.8 
  A  0   6.2  2  0.2     B  0   3.7  3  0.4     A  1   9.2  3    0     F  0    14  3    0 
  E  1  19.5  6  0.6     C  0    11  3  0.8     B  0  15.3  7  0.4     B  1   7.4  4  0.2 
  A  0  11.4  2  0.4     C  1  19.4  1    0     F  0   5.9  4  0.4     F  1  15.8  6  0.6 
  B  0    10  3  0.4     E  0  15.7  1  0.2     F  0    11  5    1     G  1  16.8  0  0.8 
  D  1    11  4  0.6     G  1   4.8  7    1     G  1  10.4  5    0     F  0  12.7  7    1 
  F  0   6.8  1  0.8     E  0   8.8  0  0.4     B  1   0.2  0  0.2     G  1   4.6  7  0.4 
  G  1   2.3  2  0.6     B  0  10.8  3  0.8     B  0   9.3  2  0.8     A  0   9.2  6  0.6 
  D  0   7.4  0  0.8     F  0  18.3  3  0.2     A  0   5.3  4  0.2     C  0   2.6  5    0 
  A  0  13.8  4  0.4     B  1  12.4  6  0.2     B  0   1.3  1  0.6     A  0  18.2  7    1 
  G  0   5.2  2  0.8     F  1   9.4  2  0.4     G  1  10.4  2  0.2     G  0    13  1  0.6 
  A  0  17.9  4  0.6     D  1  19.4  6  0.2     B  0  19.6  3  0.6     B  1     6  2  0.4 
  F  0  13.8  1  0.8     B  0  14.3  4  0.6     E  0  15.6  0  0.4     D  0    14  2  0.6 
  C  1   9.4  5    0     B  0  13.2  1  0.2     A  0  13.5  5  0.4     E  0   2.6  4  0.4 
  E  0  12.4  3  0.8     D  0   7.6  2  0.8     B  0  12.7  1  0.4     C  1  10.7  4  0.8 
  B  0  10.1  2  0.4     C  1  16.6  1  0.6     B  1   0.2  3  0.4     C  0  10.8  4  0.4 
  A  0   7.1  4    0     D  0  16.5  1    0     B  0  17.1  7  0.6     D  0   4.3  1    0 
  B  0    15  2    0     F  0  19.7  3  0.6     B  1   2.8  6    1     F  0  16.6  3  0.6 
  E  0  11.7  5  0.8     A  0  15.6  3  0.8     C  1   5.3  6  0.4     B  1   8.1  7  0.6 
  B  0  14.8  2    0     D  0   7.4  4  0.6     D  0   4.8  3  0.2     A  0   4.5  0  0.8 
  D  0   6.9  6  0.4     B  0   4.7  4    1     B  1   7.5  4  0.4     C  0   6.1  0  0.8 
  C  0  18.3  1    1     A  0  16.4  7  0.4     B  0   9.4  2  0.4     A  1  17.9  4  0.2 
  B  0  14.9  3  0.2     C  0  12.7  0  0.8     A  0   5.4  4  0.4     G  1  12.1  4  0.4 
;
DATA example1; SET example1;
if C in ( "A" ) then C_woe = -0.809318612 ; 
if C in ( "B" ) then C_woe = 0.1069721196 ; 
if C in ( "C" ) then C_woe = 0.6177977433 ; 
if C in ( "D" ) then C_woe = -0.403853504 ; 
if C in ( "E" ) then C_woe = -1.145790849 ; 
if C in ( "F" ) then C_woe = -0.703958097 ; 
if C in ( "G" ) then C_woe = 1.4932664807 ; 
run;



* Requires SAS/STAT 13.2 or greater
* Current macro variable values (below) run this program for variables of EXAMPLE 2 in paper;
* Long predictor names in MODEL will create long and hard to read Reports;
* Try to use Predictor names of at most 6 characters; 

/* Enter name of data set */
%LET dataset = example1;
/* Enter Predictor Variables into INPUT for use in HPLOGISTIC MODEL statement */
/* DO NOT use "-" convention */
%LET INPUT = X1 X2 X8 C_woe;
/* Enter CLASS variables from INPUT or space */
%LET CLASS = C_woe;
/* Enter target variable */
%LET TARGET = Y;
/* Criterion = AIC or SBC */
%LET CRITERION = SBC;
TITLE; /* CLEAR TITLES */
FOOTNOTE; /* CLEAR FOOTNOTES */


/* Length statements for variables:
"__Z_VariablesInModel" 
"__Z_Prior_ForwardVariables" 
"__Z_Prior_BackwardVariables" 
"__Z_vim_new" 
containing predictor names is set at 5000 */
/* If length of each name is 32 then the maximum number of predictors for INPUT is = 5000/33 */
/* Or, (sum of lengths of predictors) + (1 per predictor) <= 5000 */

%MACRO UPCASE_FORMAT;
PROC FORMAT LIBRARY = Work;
VALUE $df
/* enter VARIABLES and DF ... MACRO converts to UPCASE */
/* Example of assignment of 2 df to X2. 
	Enter within parentheses: "X1" = "2" */
%UPCASE
(

)
Other = "1"
;
run;
%MEND;
%UPCASE_FORMAT;
 
/* Count number of predictors in INPUT */
DATA _null_;
ARRAY ___xx{*} $ &INPUT;
call symput('NPred',dim(___xx));
run;

/* Start Program */
ODS OUTPUT Nobs = Nobs;
ODS OUTPUT SelectionDetails = __X_seldtl_b;
ODS OUTPUT CandidateDetails = __X_candtl_b;
PROC HPLOGISTIC DATA=&dataset NAMELEN = 32;
   CLASS &CLASS;
   MODEL &TARGET (descending) = &INPUT;
   SELECTION METHOD=backward(select = &CRITERION choose = &CRITERION Stop = NONE)
   DETAILS=ALL;
run;
DATA _NULL_; SET Nobs;
If label = "Number of Observations Used"; 
CALL SYMPUT('obs', N);
 
DATA __X_canseldtl_b; MERGE __X_seldtl_b __X_candtl_b; BY step;
run;

PROC PRINT DATA = __X_canseldtl_b; 
VAR Step NumberInModel EffectRemoved Effect Criterion;
Title "MODELS FROM METHOD=BACKWARD";
run;
Title;
 
DATA __X_VariablesInModel_B; SET __X_canseldtl_b end=eof; BY step;
LENGTH __Z_Prior_BackwardVariables __Z_VariablesInModel $5000;
RETAIN __Z_Prior_BackwardVariables;

IF "&CRITERION" = "SBC" THEN AICEst = .; /* to avoid warning message: AICEst uninitialized */
IF "&CRITERION" = "AIC" THEN BICEst = .; /* to avoid warning message: BICEst uninitialized */

/* Criterion for step 0 is missing in candidate data set */
IF step = 0 & "&CRITERION" = "SBC" THEN Criterion = BICEst; 
	ELSE IF step = 0 & "&CRITERION" = "AIC" THEN Criterion = AICEst;

IF step = 0 THEN DO;;
	__Z_Prior_BackwardVariables = ","||upcase(left(compbl("&INPUT")))||",";
	__Z_Prior_BackwardVariables = tranwrd(__Z_Prior_BackwardVariables," " , ",");
	END;
 
Effect_C = trim(compress("," || trim(Upcase(Effect)) || ","));
EffectRemoved_C = trim(compress("," || trim(Upcase(EffectRemoved)) || ","));
 
IF step >= 0 THEN DO;
	__Z_VariablesInModel = tranwrd(__Z_Prior_BackwardVariables,trim(Effect_C)," ");
	__Z_VariablesInModel = left(compbl(tranwrd(__Z_VariablesInModel,"," , " ")));
	OUTPUT;
	END;
 
IF last.step & step >= 0 THEN 
	__Z_Prior_BackwardVariables = tranwrd(__Z_Prior_BackwardVariables,trim(EffectRemoved_C),",");
run;
 
ODS OUTPUT SelectionDetails = __X_seldtl_f;
ODS OUTPUT CandidateDetails = __X_candtl_f;
PROC HPLOGISTIC DATA=&dataset NAMELEN = 32;
   CLASS &CLASS;
   MODEL &TARGET (descending) = &INPUT;
   SELECTION METHOD=forward(select = &CRITERION choose = &CRITERION Stop = NONE)
   DETAILS=ALL;
run;
DATA __X_canseldtl_f; MERGE __X_seldtl_f __X_candtl_f; BY step;
	IF "&CRITERION" = "SBC" THEN AICEst = .; /* to avoid warning message: AICEst uninitialized */
	IF "&CRITERION" = "AIC" THEN BICEst = .; /* to avoid warning message: BICEst uninitialized */
	IF EffectEntered = "Initial Model" THEN EffectEntered = "";
/* "Criterion" for step 0 is missing from candidate data set */
	IF step = 0 & "&CRITERION" = "SBC" THEN Criterion = BICEst; 
	ELSE IF step = 0 & "&CRITERION" = "AIC" THEN Criterion = AICEst;
run;

DATA __X_VariablesInModel_F; SET __X_canseldtl_f; BY step;
LENGTH __Z_Prior_ForwardVariables __Z_VariablesInModel $5000;
RETAIN __Z_Prior_ForwardVariables;
IF first.step THEN 
	__Z_VariablesInModel = upcase(left(trim(left(__Z_Prior_ForwardVariables)) || " " || EffectEntered));
ELSE __Z_VariablesInModel = upcase(left(trim(left(__Z_Prior_ForwardVariables)) || " " || Effect));
IF last.step 
	THEN __Z_Prior_ForwardVariables = upcase(trim(left(__Z_Prior_ForwardVariables)) || " " || EffectEntered);
run;
 
DATA __X_VariablesInModel; LENGTH CandidateFor $7; 
SET __X_VariablesInModel_F __X_VariablesInModel_B;
	LENGTH __Z_n_var $32 __Z_vim_new $5000;
	DROP I __Z_n_len __Z_n_pos __Z_n_var;
	DO I = 1 TO &Npred;
		__Z_n_var = left(trim(scan(__Z_VariablesInModel,I,' ')));
		IF __Z_n_var > ''
		THEN
		DO;
			__Z_n_len = length(__Z_n_var);
			__Z_n_pos = indexw(upcase("&input"),__Z_n_var);
			SUBSTR(__Z_vim_new,__Z_n_pos,__Z_n_len) = __Z_n_var;
			END;
		END;
	__Z_vim_new = left(trim(compbl(__Z_vim_new)));
run;
 
DATA _null_;                                            
	IF (CEXIST("WORK.formats.df.formatc")) THEN CALL SYMPUT('df_exists', "Y");
	 ELSE CALL SYMPUT('df_exists', "N");
run;
DATA _null_;
put "&df_exists";
IF "&df_exists" = "Y" THEN CALL SYMPUT( 'df_call',"+ (put(varname,$df.) - 1)");
 ELSE CALL SYMPUT('df_call', "");
run; 
DATA _null_;
put "&df_call";
run;

DATA __X_VariablesInModel2; SET __X_VariablesInModel;
DROP I varname;
LABEL __Z_DF_add = "Incremental DF from Format";
__Z_DF_add = 0;
	DO I = 1 TO &Npred;
		varname = upcase(left(trim(scan(__Z_VariablesInModel,I,' '))));
		IF varname > '' THEN __Z_DF_add = __Z_DF_add &df_call;
		END;
	IF "&CRITERION" = "SBC" THEN criterion = criterion + log(&obs) * __Z_DF_add;
	IF "&CRITERION" = "AIC" THEN criterion = criterion + 2 * __Z_DF_add;
run;

PROC SORT DATA = __X_VariablesInModel2 OUT = __X_VariablesInModel_sorted; 
BY __Z_vim_new criterion;
run;
 
DATA __X_Report; SET __X_VariablesInModel_sorted;
BY __Z_vim_new criterion;
	LABEL __Z_vim_new = "Variables in Model from consolidated F and B";
	LABEL __Z_average_criterion = "Average &Criterion";
	LABEL __Z_min_criterion = "Minimum &Criterion";
	LABEL __Z_model_count = "# of Models in Average";
	RETAIN __Z_model_count __Z_sum_criterion __Z_min_criterion; 
	IF first.__Z_vim_new
	THEN
	DO;
   	__Z_model_count = 0;
   	__Z_sum_criterion = 0;
		__Z_min_criterion = .;
   	END;
	__Z_model_count+1;
	__Z_sum_criterion + criterion;
	__Z_min_criterion = min(criterion, __Z_min_criterion);
	IF last.__Z_vim_new THEN DO;
	/* Small differences may exist in SBC or AIC in Forward v Backward */
	/* Average is taken */
   	__Z_average_criterion = __Z_sum_criterion/__Z_model_count;
   	OUTPUT;
   	END;
run;
PROC SORT DATA = __X_Report; BY __Z_average_criterion;
run;

DATA _NULL_;
LENGTH ONES5000 $5000;
ONES5000 = "1";
DO I = 1 to 4999;
	ONES5000 = TRIM(ONES5000) || "1";
	END;
CALL SYMPUT('ONES5000',ONES5000);
run;
PROC FORMAT LIBRARY = Work;
VALUE $____Null
"1" = "&ONES5000"
" " = "Intercept Only";
run;
PROC PRINT DATA = __X_Report LABEL; 
VAR __Z_vim_new __Z_average_criterion __Z_min_criterion __Z_model_count;
FORMAT __Z_vim_new $____Null.;
TITLE "Models from B-F Process - Sorted by Average (approx) &CRITERION";
run;
